# concbeam.rb  Stuart S. Nielsen
# Draw a cross-section of a beam.

require 'sketchup.rb'

def sn			
	prompts = ["b width in.", "d depth in.", "As sq. in", "f'c psi", "fy psi"]
    values = [10.inch, 20.inch, 4.0, 4000, 60000]
		
	 results = inputbox prompts, values, $exStrings.GetString("Beam Information")	
	
		b, d, as, fc, fy = results
	# height of the stress block
		a = (as * fy ) / (0.85 * fc * b)
		c = a / 0.85
	# strain in the steel	
		es = 0.003 * ( d - c ) / c
	# reduction factor for the beam	
		if es >= 0.005 then
	  phi = 0.9
	else
	  phi = 0
	end
	# Nominal moment strength	
		mn = (as * fy * (d - (as * fy) / (1.7 * fc * b)) / 12000)
	# ACI Design strength of the beam	
		phimn = phi * mn
	# Design strength output	
	UI.messagebox "phiMn =" + phimn.to_s 
	
	model = Sketchup.active_model
    model.start_operation $exStrings.GetString("Create Box")
	entities = model.active_entities

	# Here I would output a cross section of the beam showing the rebar layout
    group = entities.add_group
    entities = group.entities
	 pts = []
    pts[0] = [0, 0, 0]
    pts[1] = [0, b, 0]
    pts[2] = [0, b, d]
    pts[3] = [0, 0, d]
	
    base = entities.add_face pts
	
end		 
if( not file_loaded?("concbeam.rb") ) 
    UI.menu("Draw").add_item("Concbeam") { sn.concbeam }
end

file_loaded("concbeam.rb")